<?php

if (!(
	file_exists(__DIR__.'/vendor/amphp/amp') &&
	file_exists(__DIR__.'/vendor/amphp/byte-stream') &&
	file_exists(__DIR__.'/vendor/amphp/websocket-client')))
{
	system('cd '.__DIR__.';composer require amphp/websocket-client amphp/byte-stream amphp/amp');
}

require __DIR__.'/vendor/autoload.php';

use function \Amp\async;
use function \Amp\delay;
use function \Amp\Websocket\Client\connect;
use function \Amp\ByteStream\getStdin;
use \Amp\ByteStream\BufferedReader;

echo 'connecting -';

$conn = false;

$spin = 0;

async(function() {
	global $conn, $spin;

	while (!$conn) {
		$spin += 1;
		$spin %= 4;
		echo "\x08".['-','\\',"|",'/'][$spin];
		delay(0.1);
	}
});

$conn = connect('wss://codeguessing.gay/73/ws');
echo "\r            \r";

\Amp\async(function() {
	global $conn;

	foreach($conn as $msg) {
		$msg = $msg->buffer();
		$msg = json_decode($msg);

		switch($msg->reason) {

		case "connect":
			echo"*** ".$msg->name." joined the game. ***\n";
			break;

		case "disconnect":
			echo "*** ".$msg->name." left the game. ***\n";
			break;

		case "message":
			echo "<".$msg->name."> ".$msg->content."\n";
			break;
		}
	}
});

$io = new BufferedReader(getStdin());

while(1) {
	try {
		$x = $io->readUntil("\n");
	} catch (Exception $e) {
		break;
	}
	$conn->sendText(json_encode(["content" => $x]));
}

